// Chope de bire.
// Dcor de fond.

#declare Offset_Fond = 70

/******************************************************************************

        Dcor de fond, insignifiant

******************************************************************************/

/******************************************************************************

        Textures

******************************************************************************/

#declare Fin_Bois  = finish {ambient 0.5 diffuse 0.5}
#declare Fin_Bois1 = finish {ambient 0.20 diffuse 0.35}
#declare Fin_Bois2 = finish {ambient 0.20 diffuse 0.35}

#declare Bois_Fond = pigment {
   wood
   turbulence 0.08            // For best results,  keep this low!
   scale <0.2 0.2 1>          // Scaled or a unit object
   octaves 3 lambda 5 omega .6
   colour_map {
      [0.00 0.10 color red 0.42 green 0.26 blue 0.15
      color red 0.42 green 0.26 blue 0.15]
      [0.10 0.90 color red 0.42 green 0.26 blue 0.15
      color red 0.52 green 0.37 blue 0.26 ]
      [0.90 1 color red 0.52 green 0.37 blue 0.26
      color red 0.52 green 0.37 blue 0.26  ]
      }
   scale <5, 3, 3>
   rotate .1*x
   warp{
      black_hole <0, .5, 0>, 3
      falloff .5 strength 0.75 inverse
      repeat <0, 0, 50> turbulence <5, 0.5, 30>
      }
   rotate 90*x
   }

#declare Bois_Fenetre1 =
   pigment {
      wood
      turbulence 0.07            // was .04; For best results,  keep this low!
      octaves 3
      scale <0.2 0.2 1>          // Scaled or a unit object
      colour_map {
         [0.00 0.10 color red 0.60 green 0.30 blue 0.18
         color red 0.60 green 0.30 blue 0.18 ]
         [0.10 0.90 color red 0.60 green 0.30 blue 0.18
         color red 0.30 green 0.15 blue 0.09 ]
         [0.90 1 color red 0.30 green 0.15 blue 0.09
         color red 0.30 green 0.15 blue 0.09  ]
      }
      rotate 92*x
      rotate 90*z
      //rotate 92*y
      scale <2, 1, 1>
      warp{
         black_hole <1, .5, 0>, 2
         falloff 1 strength 0.75 inverse
         repeat <20, 0, 0> turbulence <10.0, 1, 0.5>
         }
      warp{
         black_hole <6, 2, 3>, 1
         falloff .5 strength 1.75 inverse
         repeat <30, 0, 0> turbulence <13.0, 0.5, .5>
         }
      }

///////////////////////////////////////////////////////////////////////////////
#declare Cube_Fond = object {
///////////////////////////////////////////////////////////////////////////////
   difference {
      box {<-1000000, -121, -1000000>, <1000000, 1000000, Offset_Fond+1.51>}
      box {< -999999,  -120,  -999999>, < 999999,  999999,  Offset_Fond+1.5>}
      }
   texture {
      pigment{Bois_Fond scale .1 turbulence 0.1 }
      finish {Fin_Bois1}
      }
   }

///////////////////////////////////////////////////////////////////////////////
#declare Cube_Noir = object {
///////////////////////////////////////////////////////////////////////////////
   box {<-200, -1000, Offset_Fond +1>, <40, 1000, Offset_Fond +2>}
   texture {
      pigment {color Black}
      finish {
         ambient 1.0
         diffuse 0.0
         }
      }
}

///////////////////////////////////////////////////////////////////////////////
#declare Fenetre1=object{
///////////////////////////////////////////////////////////////////////////////
   difference{
      box{<0, 0, 0>, <1000, 2, 6>}
      box{<-40, -100, -1>, <0, 100, 7> rotate -45*z}
      }
   texture{
      pigment {Bois_Fenetre1}
      finish {Fin_Bois2}
      }
   translate <-40, -12, Offset_Fond-1>
   }

///////////////////////////////////////////////////////////////////////////////
#declare Fenetre2=object{
///////////////////////////////////////////////////////////////////////////////
   difference{
      box{<0, 0, 0>, <1000, 2, 6>}
      box{<-40, -100, -1>, <0, 100, 7> rotate -45*z}
      }
   rotate 90*z
   rotate 180*y
   translate 6*z
   texture{
      pigment {Bois_Fenetre1}
      finish {Fin_Bois2}
      rotate 90*z
      translate 2*x + 100*y
      }
   translate <-40, -12, Offset_Fond-1>
   }

///////////////////////////////////////////////////////////////////////////////
#declare Fenetre=union{
///////////////////////////////////////////////////////////////////////////////
   object{Fenetre1}
   object{Fenetre2}
   }

///////////////////////////////////////////////////////////////////////////////
#declare Fond1 = object {
///////////////////////////////////////////////////////////////////////////////
   box {<-9.8, -1000000, 0>, <9.8, 1000000, 0.01>}
   texture {
      pigment {Bois_Fond /*turbulence 0.1 scale <3, 3, 3>*/}
      finish {Fin_Bois1}
      }
   translate <0, 0, Offset_Fond >
   }

///////////////////////////////////////////////////////////////////////////////
#declare Fond2=union {
///////////////////////////////////////////////////////////////////////////////
   object {Cube_Fond}
   object {Cube_Noir}
   union {
      object {Fond1 translate <  60,  4554, 0>}
      object {Fond1 translate <  40, 94554, 0>}
      object {Fond1 translate <  20, 14532, 0>}
      object {Fond1 translate <   0,     0, 0>}
      object {Fond1 translate < -20, 39137, 0>}
      object {Fond1 translate < -40,   681, 0>}
      object {Fond1 translate < -60,  6871, 0>}
      object {Fond1 translate < -80, 91378, 0>}
      object {Fond1 translate <-100,  1000, 0>}
      object {Fond1 translate <-120, 31864, 0>}
      object {Fond1 translate <-140, 39478, 0>}
      object {Fond1 translate <-160, 26745, 0>}
      object {Fond1 translate <-200, 33698, 0>}
      object {Fond1 translate <-220,  3698, 0>}
      scale <.35, 1, 1> translate -5*x
      }
   clipped_by {
      difference{
         box {<-2000000, -2000000, -2000000>, <2000000, 2000000, 2000000>}
         box {<-40, -12, Offset_Fond - 10>, <100, 100, Offset_Fond+10>}
         }
      }
   }

///////////////////////////////////////////////////////////////////////////////
#declare Vitre=object{
///////////////////////////////////////////////////////////////////////////////
   box{<-41, -13, Offset_Fond + 1.5>, <102, 102, Offset_Fond+1.9>}
   texture{
      pigment{color rgbt<.8, .8, .8, .3>}
      normal{
         bumps scale 10
         bump_size 0.07
         }
      finish{ambient 0.1 diffuse 0.1 reflection .3}
      }
   }

///////////////////////////////////////////////////////////////////////////////
#declare Tube_Bleu=object{
///////////////////////////////////////////////////////////////////////////////
   cylinder{0*x, x, 1 hollow}
   texture {
      pigment { color Clear }
      finish { ambient 0 diffuse 0 }
      halo{
         emitting cylindrical_mapping
         poly exponent 2 max_value 1
         color_map{
            [0.0 color rgbt<.1, .2, .8, 0>]
            [0.8 color rgbt<.8, .8, 1, .8>]
            [1.0 color rgbt<.8, .8, 1, 1>]
            }
         samples 10 jitter 0.3
         rotate 90*z
         }
      }
   scale <1, .5, .5>
   }

///////////////////////////////////////////////////////////////////////////////
#declare Sph_Bleue=object{
///////////////////////////////////////////////////////////////////////////////
   sphere{0*x, 1 hollow}
   texture {
      pigment { color Clear }
      finish { ambient 0 diffuse 0 }
      halo{
         emitting spherical_mapping
         poly exponent 2 max_value 1
         color_map{
            [0.0 color rgbt<.1, .2, .8, 0>]
            [0.8 color rgbt<.8, .8, 1, .8>]
            [1.0 color rgbt<.8, .8, 1, 1>]
            }
         samples 10 jitter 0.3
         }
      }
   scale .5
   }

///////////////////////////////////////////////////////////////////////////////
#declare Tube_Rouge=object{
///////////////////////////////////////////////////////////////////////////////
   cylinder{0*x, x, 1 hollow}
   texture {
      pigment { color Clear }
      finish { ambient 0 diffuse 0 }
      halo{
         emitting cylindrical_mapping
         poly exponent 2 max_value 1
         color_map{
            [0.0 color rgbt<.8, .2, .2, 0>]
            [0.8 color rgbt<1, .8, .8, .8>]
            [1.0 color rgbt<1, .8, .81, 1>]
            }
         samples 10 jitter 0.3
         rotate 90*z
         }
      }
   scale <1, .5, .5>
   }

///////////////////////////////////////////////////////////////////////////////
#declare Sph_Rouge=object{
///////////////////////////////////////////////////////////////////////////////
   sphere{0*x, 1 hollow}
   texture {
      pigment { color Clear }
      finish { ambient 0 diffuse 0 }
      halo{
         emitting spherical_mapping
         poly exponent 2 max_value 1
         color_map{
            [0.0 color rgbt<.8, .2, .2, 0>]
            [0.8 color rgbt<1, .8, .8, .8>]
            [1.0 color rgbt<1, .8, .81, 1>]
            }
         samples 10 jitter 0.3
         }
      }
   scale .5
   }

///////////////////////////////////////////////////////////////////////////////
#declare TubeR_H=union {
///////////////////////////////////////////////////////////////////////////////
   object {Tube_Rouge scale <20, 1, 1> rotate 90*z}
   object {Sph_Rouge}
   object {Tube_Rouge scale <1, 1, 1> }
   object {Sph_Rouge translate 1*x}
   object {Tube_Rouge scale <10, 1, 1> rotate 90*z translate <1, 0, 0>}
   object {Sph_Rouge translate <1, 10, 0>}
   object {Tube_Rouge scale <8, 1, 1> translate <1, 10, 0>}
   object {Sph_Rouge translate <9, 10, 0>}
   object {Tube_Rouge scale <10, 1, 1> rotate 90*z translate <9, 10, 0>}
   object {Sph_Rouge translate <9, 20, 0>}
   object {Tube_Rouge scale <1, 1, 1> translate <9, 20, 0>}
   object {Sph_Rouge translate <10, 20, 0>}
   object {Tube_Rouge scale <20, 1, 1> rotate 90*z translate <10, 0, 0>}
   }
#declare TubeR_A=union {
   object {Tube_Rouge scale <21.36, 1, 1> rotate 69.44*z}
   object {Sph_Rouge translate <7.5, 20, 0>}
   object {Tube_Rouge scale <21.36/2-.5, 1, 1> rotate -69.44*z translate <7.5, 20, 0>}
   object {Sph_Rouge translate <11.25, 10.5, 0>}
   object {Tube_Rouge scale <6.5, 1, 1> translate <4.75, 10.5, 0>}
   object {Sph_Rouge translate <4.75, 10.5, 0>}
   object {Tube_Rouge scale <1, 1, 1> rotate 90*z translate <4.75, 9.5, 0>}
   object {Sph_Rouge translate <4.75, 9.5, 0>}
   object {Tube_Rouge scale <6.5, 1, 1> translate <4.75, 9.5, 0>}
   object {Sph_Rouge translate <11.25, 9.5, 0>}
   object {Tube_Rouge scale <21.36/2, 1, 1> rotate (180-69.44)*z translate <15, 0, 0>}
   }
#declare TubeR_P=union {
   object {Tube_Rouge scale <20, 1, 1> rotate 90*z}
   object {Sph_Rouge translate <0, 20, 0>}
   object {Tube_Rouge scale <10, 1, 1> translate <0, 20, 0>}
   object {Sph_Rouge translate <10, 20, 0>}
   object {Tube_Rouge scale <3.54, 1, 1> rotate -45*z translate <10, 20, 0>}
   object {Sph_Rouge translate <12.5, 17.5, 0>}
   object {Tube_Rouge scale <5, 1, 1> rotate 90*z translate <12.5, 12.5, 0>}
   object {Sph_Rouge translate <12.5, 12.5, 0>}
   object {Tube_Rouge scale <3.54, 1, 1> rotate 45*z translate <10, 10, 0>}
   object {Sph_Rouge translate <10, 10, 0>}
   object {Tube_Rouge scale <9, 1, 1> translate <1, 10, 0>}
   }
#declare TubeR_Y=union {
   object {Tube_Rouge scale <12.21, 1, 1> rotate -55*z translate <0, 20, 0>}
   object {Sph_Rouge translate <7, 10, 0>}
   object {Tube_Rouge scale <10, 1, 1> rotate 90*z translate <7, 0, 0>}
   object {Sph_Rouge translate <7, 0, 0>}
   object {Tube_Rouge translate <7, 0, 0>}
   object {Sph_Rouge translate <8, 0, 0>}
   object {Tube_Rouge scale <10, 1, 1> rotate 90*z translate <8, 0, 0>}
   object {Sph_Rouge translate <8, 10, 0>}
   object {Tube_Rouge scale <12.21, 1, 1> rotate 55*z translate <8, 10, 0>}
   }
#declare TubeR_O=union {
   object {Tube_Rouge scale <15, 1, 1> rotate 90*z translate <0, 2.5, 0>}
   object {Tube_Rouge scale <3.54, 1, 1> rotate 45*z translate <0, 17.5, 0>}
   object {Tube_Rouge scale <5, 1, 1> translate <2.5, 20, 0>}
   object {Tube_Rouge scale <3.54, 1, 1> rotate -45*z translate <7.5, 20, 0>}
   object {Tube_Rouge scale <15, 1, 1> rotate 90*z translate <10, 2.5, 0>}
   object {Tube_Rouge scale <3.54, 1, 1> rotate 45*z translate <7.5, 0, 0>}
   object {Tube_Rouge scale <5, 1, 1> translate <2.5, 0, 0>}
   object {Tube_Rouge scale <3.54, 1, 1> rotate -45*z translate <0, 2.5, 0>}
   object {Sph_Rouge translate <0, 2.5, 0>}
   object {Sph_Rouge translate <10, 2.5, 0>}
   object {Sph_Rouge translate <0, 17.5, 0>}
   object {Sph_Rouge translate <10, 17.5, 0>}
   object {Sph_Rouge translate <2.5, 0, 0>}
   object {Sph_Rouge translate <7.5, 0, 0>}
   object {Sph_Rouge translate <2.5, 20, 0>}
   object {Sph_Rouge translate <7.5, 20, 0>}
   }
#declare TubeR_U=union {
   object {Tube_Rouge scale <17.5, 1, 1> rotate 90*z translate <0, 2.5, 0>}
   object {Sph_Rouge translate <0, 2.5, 0>}
   object {Tube_Rouge scale <17.5, 1, 1> rotate 90*z translate <10, 2.5, 0>}
   object {Sph_Rouge translate <10, 2.5, 0>}
   object {Tube_Rouge scale <3.54, 1, 1> rotate 45*z translate <7.5, 0, 0>}
   object {Sph_Rouge translate <7.5, 0, 0>}
   object {Tube_Rouge scale <5, 1, 1> translate <2.5, 0, 0>}
   object {Sph_Rouge translate <2.5, 0, 0>}
   object {Tube_Rouge scale <3.54, 1, 1> rotate -45*z translate <0, 2.5, 0>}
   }
#declare TubeR_R=union {
   object {Tube_Rouge scale <20, 1, 1> rotate 90*z}
   object {Sph_Rouge translate <0, 20, 0>}
   object {Tube_Rouge scale <10, 1, 1> translate <0, 20, 0>}
   object {Sph_Rouge translate <10, 20, 0>}
   object {Tube_Rouge scale <3.54, 1, 1> rotate -45*z translate <10, 20, 0>}
   object {Sph_Rouge translate <12.5, 17.5, 0>}
   object {Tube_Rouge scale <5, 1, 1> rotate 90*z translate <12.5, 12.5, 0>}
   object {Sph_Rouge translate <12.5, 12.5, 0>}
   object {Tube_Rouge scale <3.54, 1, 1> rotate 45*z translate <10, 10, 0>}
   object {Sph_Rouge translate <10, 10, 0>}
   object {Tube_Rouge scale <9, 1, 1> translate <1, 10, 0>}
   object {Sph_Rouge translate <1, 10, 0>}
   object {Tube_Rouge scale <15.24, 1, 1> rotate -41*z translate <1, 10, 0>}
   }
#declare TubeB_6=union {
   object {Tube_Bleu scale <20, 1, 1> rotate 90*z}
   object {Tube_Bleu scale <10, 1, 1> rotate 90*z translate <10, 0, 0>}
   object {Tube_Bleu scale <10, 1, 1> translate <0, 20, 0>}
   object {Tube_Bleu scale <10, 1, 1> translate <0, 10, 0>}
   object {Tube_Bleu scale <10, 1, 1> translate <0, 0, 0>}
   }
#declare TubeB_8=union {
   object {Tube_Bleu scale <20, 1, 1> rotate 90*z}
   object {Tube_Bleu scale <10, 1, 1> rotate 90*z translate <10, 0, 0>}
   object {Tube_Bleu scale <10, 1, 1> rotate 90*z translate <10, 10, 0>}
   object {Tube_Bleu scale <10, 1, 1> translate <0, 20, 0>}
   object {Tube_Bleu scale <10, 1, 1> translate <0, 10, 0>}
   object {Tube_Bleu scale <10, 1, 1> translate <0, 0, 0>}
   }
#declare TubeB_P=union {
   object {Tube_Bleu scale <20, 1, 1> rotate 90*z}
   object {Sph_Bleue translate <0, 20, 0>}
   object {Tube_Bleu scale <10, 1, 1> translate <0, 20, 0>}
   object {Sph_Bleue translate <10, 20, 0>}
   object {Tube_Bleu scale <3.54, 1, 1> rotate -45*z translate <10, 20, 0>}
   object {Sph_Bleue translate <12.5, 17.5, 0>}
   object {Tube_Bleu scale <5, 1, 1> rotate 90*z translate <12.5, 12.5, 0>}
   object {Sph_Bleue translate <12.5, 12.5, 0>}
   object {Tube_Bleu scale <3.54, 1, 1> rotate 45*z translate <10, 10, 0>}
   object {Sph_Bleue translate <10, 10, 0>}
   object {Tube_Bleu scale <9, 1, 1> translate <1, 10, 0>}
   }
#declare TubeB_M=union {
   object {Tube_Bleu scale <20, 1, 1> rotate 90*z}
   object {Sph_Bleue translate <0, 20, 0>}
   object {Tube_Bleu scale <12.5, 1, 1> rotate -53.13*z translate <0, 20, 0>}
   object {Sph_Bleue translate <7.5, 10, 0>}
   object {Tube_Bleu scale <12.5, 1, 1> rotate 53.13*z translate <7.5, 10, 0>}
   object {Sph_Bleue translate <15, 20, 0>}
   object {Tube_Bleu scale <20, 1, 1> rotate 90*z translate <15, 0, 0>}
   }
///////////////////////////////////////////////////////////////////////////////
#declare Happy=union {
   object{TubeR_H}
   object{TubeR_A translate (10+1)*x}
   object{TubeR_P translate (10+1+15+1)*x}
   object{TubeR_P translate (10+1+15+1+12.5+1.5)*x}
   object{TubeR_Y translate (10+1+15+1+12.5+1.5+12.5+1)*x}
   }
#declare Hour=union {
   object{TubeR_H}
   object{TubeR_O translate (10+1.5)*x}
   object{TubeR_U translate (10+1.5+10+1.5)*x}
   object{TubeR_R translate (10+1.5+10+1.5+10+1.5)*x}
   }
#declare Time=union {
   object{TubeB_6}
   object {Tube_Bleu scale <10, 1, 1> translate 10*y translate (10+6)*x}
   object{TubeB_8 translate (10+6+10+6)*x}
   object{TubeB_P translate (10+6+10+6+10+6)*x}
   object{TubeB_M translate (10+6+10+6+10+6+12.5+1.5)*x}
   }
#declare Happy_Hour=union{
   object{Happy translate 20*y}
   object{Hour translate (10+1+15+1+12.5+1.5+12.5+1+15+1+10)*x + 20*y}
   object{Time scale .7 translate (120.5-(77*.7))/2*x}
   scale .5 rotate 180*y
   }
///////////////////////////////////////////////////////////////////////////////
#declare Fond=union {
///////////////////////////////////////////////////////////////////////////////
   object {Happy_Hour scale .6 translate <10, -6, Offset_Fond+.75>}
   object {Vitre}
   object {Fond2}
   object {Fenetre}
   }
